#include "StdAfx.h"
#include ".\filestuff.h"

CFileStuff::CFileStuff(void)
{
}

CFileStuff::~CFileStuff(void)
{
}

BOOL CFileStuff::UserBrowseOpen(CString *pPath, LPCTSTR Filter, LPCTSTR DefaultExt)
{

	OPENFILENAME	ofn;

	LPTSTR lpPathBuff = pPath->GetBuffer(MAX_PATH);

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = Filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = DefaultExt;
	ofn.lpstrFile = lpPathBuff;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrCustomFilter = NULL;
	ofn.lpstrTitle = m_windowTitle;  // window title
	ofn.Flags = OFN_HIDEREADONLY+OFN_EXPLORER;
	


	// display file open/save dialog
	BOOL result;
	result = GetOpenFileName(&ofn);

	pPath->ReleaseBuffer();

	return result;
}

BOOL CFileStuff::UserBrowseSave(CString *pPath, LPCTSTR Filter, LPCTSTR DefaultExt)
{

	OPENFILENAME	ofn;

	LPTSTR lpPathBuff = pPath->GetBuffer(MAX_PATH);

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = Filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrDefExt = DefaultExt;
	ofn.lpstrFile = lpPathBuff;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrCustomFilter = NULL;
	ofn.lpstrTitle = m_windowTitle;  // window title
	ofn.Flags = OFN_HIDEREADONLY+OFN_EXPLORER;
	
	// display file open/save dialog
	BOOL result;
	result = GetSaveFileName(&ofn);

	pPath->ReleaseBuffer();

	return result;
}

// part of user browse folder below
int CALLBACK BrowseCallbackProc(HWND hwnd,
    UINT uMsg,LPARAM lParam,LPARAM lpData)
{
//	CRegistry regMyReg( NULL );  // No special flags
	CString Path;

	// Look for BFFM_INITIALIZED so we know our dialog is available
	if(uMsg == BFFM_INITIALIZED)
    {
		//if ( regMyReg.Open("Software\\MobyNames",HKEY_CURRENT_USER) ) 
		//{
		//	// get registry value
		Path = "c:\\"; //regMyReg["SourceDir"];
		//	// Close the open key
		//	regMyReg.Close();
		//}
		SendMessage(hwnd, BFFM_SETSELECTION,
			TRUE, (LPARAM)(LPCTSTR)(Path)); 
    }
    return 0;
}

BOOL CFileStuff::UserBrowseFolder(CString &folderpath, const char* szCaption, HWND hOwner)
{
	BOOL retVal = false;

	// The BROWSEINFO struct tells the shell 
	// how it should display the dialog.
	BROWSEINFO bi;
	memset(&bi, 0, sizeof(bi));

	bi.ulFlags   = BIF_USENEWUI | BIF_VALIDATE;
	bi.hwndOwner = hOwner;
	bi.lpszTitle = szCaption;
	
	// Set the callback function
    bi.lpfn = BrowseCallbackProc;

	// must call this if using BIF_USENEWUI
	::OleInitialize(NULL);

	// Show the dialog and get the itemIDList for the selected folder.
	LPITEMIDLIST pIDL = ::SHBrowseForFolder(&bi);

	if(pIDL != NULL)
	{
		// Create a buffer to store the path, then get the path.
		char buffer[_MAX_PATH] = {'\0'};
		if(::SHGetPathFromIDList(pIDL, buffer) != 0)
		{
			// Set the string value.
			folderpath = buffer;
			retVal = true;
		}		

		// free the item id list
		CoTaskMemFree(pIDL);
	}

	::OleUninitialize();

	return retVal;
}

	

// returns false when EOF reached
bool CFileStuff::loadFile(FILE* pinputFile, CString &fileData)
{
	bool eof = false;	// reached end of file?
	char buffer[200];
	bool flag=false;
	fileData = "";
	CString tmp;

	while (1)
	{
	if (fgets(buffer,sizeof(buffer),pinputFile) != NULL)
			{	
				tmp=buffer;
				fileData +=tmp;
			}
	else
		{
			eof = true;	// flag EOF
			break;  // exit while loop on read error
		}
	}
	return !eof;
}