// FuzzyRenameDlg.cpp : implementation file
//
// fuzzy rename
// jeff leyda  2008
// jeff@silent.net
// 
// chunks of source (easysize, SADirRead, similar) are not mine-authorship remains intact in their respective source files.
//
#include "stdafx.h"
#include "FuzzyRename.h"
#include "FuzzyRenameDlg.h"
#include ".\fuzzyrenamedlg.h"
#include "fileStuff.h"
#include "similar.h"
#include "SADirRead.h"
#include "progressDlg.h"
#include "NewFilenameDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFuzzyRenameDlg dialog

//
// ok, get a source directory of filenames that we want to rename (pngs)
// then get a destination directory of filenames that are similar. (roms)
// for each filename in the roms folder, fuzzy match the closest png filename.
// browse to a 3rd folder as a destination as to where the new png files will be copied to.
// we must copy files instead of renaming them, because there may be dupes that use the same source png.
// that way we don't mess with the original file sets either.
//


CFuzzyRenameDlg::CFuzzyRenameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFuzzyRenameDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFuzzyRenameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_FILES2RENAME, m_SourceFiles);

}

BEGIN_MESSAGE_MAP(CFuzzyRenameDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SOURCEDIRBROWSE, OnBnClickedSourcedirbrowse)
	ON_BN_CLICKED(IDC_SOURCENAMESDIRBROWSE, OnBnClickedSourcenamesdirbrowse)
	ON_NOTIFY(NM_RCLICK, IDC_FILES2RENAME, OnNMRclickList)
	ON_NOTIFY(LVN_KEYDOWN, IDC_FILES2RENAME, OnLvnKeydown)
	ON_NOTIFY(NM_DBLCLK, IDC_FILES2RENAME, OnNMDblclk)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_DESTINATIONFOLDERBROWSE, OnBnClickedDestinationfolderbrowse)
END_MESSAGE_MAP()

BEGIN_EASYSIZE_MAP(CFuzzyRenameDlg)
	EASYSIZE(IDC_FILES2RENAME,ES_BORDER,IDC_IGNOREJUNK,ES_BORDER,ES_BORDER,0)
END_EASYSIZE_MAP

// CFuzzyRenameDlg message handlers
void CFuzzyRenameDlg::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy);
    UPDATE_EASYSIZE;
}

BOOL CFuzzyRenameDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_SourceFiles.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_SourceFiles.SetHeadings( _T("ROM Name,240; Closest Match,240;  New Name,240;") );
	m_SourceFiles.LoadColumnInfo();
	m_DestinationPath = "";

//	((CButton*)GetDlgItem(IDC_IGNOREJUNK))->SetCheck(1);
	((CButton*)GetDlgItem(IDOK))->EnableWindow(0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFuzzyRenameDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFuzzyRenameDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


// get source directory - files that we want to rename.
void CFuzzyRenameDlg::OnBnClickedSourcedirbrowse()
{
	CFileStuff fileStuff;
	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(m_SourcePath, "Folder of files to rename...") != TRUE)
		return;
	m_SourcePath+="\\";

	// now we have the path+filename we want to work with.
	// scan all the files in this selected folder.
	m_pngDir.ClearDirs();
	m_pngDir.ClearFiles();
	// look in the user folder, not recursively
	m_pngDir.GetDirs(m_SourcePath, false);


   ///////////////////////////////////////////////////
   // get all files in the dirs we found above
   m_pngDir.GetFiles("*.*");

   // sort them by name, ascending
   m_pngDir.SortFiles(CSADirRead::eSortAlpha, false);
   CSADirRead::SAFileVector &files = m_pngDir.Files();
   m_pngFiles = files.begin();
   m_SourceFiles.DeleteAllItems();
}

void CFuzzyRenameDlg::OnBnClickedSourcenamesdirbrowse()
{
	CFileStuff fileStuff;
	CString fileName;
	CString bestMatch;
	CString newName;
	CString ext;
	int pos;
	
	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(m_TargetFilesPath, "Folder of files to get filenames from...") != TRUE)
		return;
	m_TargetFilesPath+="\\";

	// now we have the path+filename we want to work with.
	// scan all the files in this selected folder.
	m_ROMsDir.ClearDirs();
	m_ROMsDir.ClearFiles();
	// look in the user folder, not recursively
	m_ROMsDir.GetDirs(m_TargetFilesPath, false);


   ///////////////////////////////////////////////////
   // get all files in the dirs we found above
   m_ROMsDir.GetFiles("*.*");

   // sort them by name, ascending
   m_ROMsDir.SortFiles(CSADirRead::eSortAlpha, false);
   CSADirRead::SAFileVector &files = m_ROMsDir.Files();
   m_ROMFiles = files.begin();

   

	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_TIMER, 1000, "Looking for names, hang on...");


	m_nIndex=0;
   while ( m_ROMFiles != files.end())
   {
	   bestMatch = "";
		fileName = (*m_ROMFiles).m_sName;
		pos = fileName.ReverseFind('\\');
		if (pos != -1)
			fileName = fileName.Right(fileName.GetLength() - pos-1 );
		
		goCompare(fileName, bestMatch);
		// get the filename minus the extension of the ROM.
		newName = fileName.Left(fileName.ReverseFind('.'));
			
		// get the extension of the snap
		ext = bestMatch.Right(bestMatch.GetLength() - bestMatch.ReverseFind('.'));

		newName +=ext;
		if (bestMatch.GetLength() == 0)
			newName="";

		m_SourceFiles.AddItem(fileName,bestMatch,newName);
		m_nIndex++;
		m_ROMFiles++;	// next rom file
		
   }
		progDlg.DestroyWindow();
}


void CFuzzyRenameDlg::OnBnClickedDestinationfolderbrowse()
{
	CFileStuff fileStuff;
	// open a "browse to folder" dialog
	if (fileStuff.UserBrowseFolder(m_DestinationPath, "Destination folder for renamed files...") != TRUE)
		return;
	m_DestinationPath+="\\";
	((CButton*)GetDlgItem(IDOK))->EnableWindow(1);
}


// compares a supplied filename against all the files in the supplied directory.
// builds a top 10 matches array, although it is not used at the moment.
// since all files are sorted alphabetically, I cheat a bit and only try and match files that are of the same letter as the source.
// this does help with correct matching (ie, Asteroids and Blasteroids) and speeds things up slightly.
// could speed things up even more by only retrieving first letter matching filenames to begin with, but this SAFile class is outside my comfort level.
bool CFuzzyRenameDlg::goCompare(CString fileName, CString &bestMatch) 
{
	CString cmpFilename, fullFilename;
	CString ext;
	float results, results2;
	float topTen=0;			// this is the lowest value needed to get into the top 10
	unsigned int pos, pos2;
	resultsArray resultsList;	// storage for top 10 matches
	bool cleaned = false;

   CSADirRead::SAFileVector &files = m_pngDir.Files();
   m_pngFiles = files.begin();
   fileName = fileName.Left(fileName.ReverseFind('.'));
	

	fileName.Trim();



   while ( (m_pngFiles) != files.end())	// for each PNG file we've got, try to find the one closest to the ROM file provided.
   {
		cmpFilename = ((*m_pngFiles).m_sName);
		m_pngFiles++;

		ext = cmpFilename.Right(cmpFilename.GetLength() - cmpFilename.ReverseFind('.'));

		pos = cmpFilename.ReverseFind('\\');
		if (pos != -1)
			cmpFilename = cmpFilename.Right(cmpFilename.GetLength() - pos-1 );
		cmpFilename = cmpFilename.Left(cmpFilename.ReverseFind('.'));


		if (cmpFilename.Left(1) == fileName.Left(1))  // first letter doesn't match?  don't even bother.
		{
			
				// exact match? we're done!
				if (cmpFilename == fileName)
					{
						bestMatch = cmpFilename+ext;
						return true;
					}


				fullFilename = cmpFilename;				// save unmodified version
				if ( ((CButton*)GetDlgItem(IDC_IGNOREJUNK))->GetCheck() == 1  )
				{
					// clean up compare to filename
					pos = cmpFilename.Find("(");
					pos2 = cmpFilename.Find("[");
					if (pos2 < pos) 
						pos = pos2;
					cmpFilename = cmpFilename.Left(pos);
					cmpFilename.Trim();

					if (!cleaned)					
					{
						pos = fileName.Find("(");
						pos2 = fileName.Find("[");
						if (pos2 < pos) 
							pos = pos2;
						fileName = fileName.Left(pos);
						fileName.Trim();
						cleaned = true;
					}
		
					
				}
	
				USES_CONVERSION;
				char* s = T2A((LPTSTR)(LPCTSTR)cmpFilename);   // get the next filename  //cmptitleOnly); 
				char* t = T2A((LPTSTR)(LPCTSTR)fileName); 
				results = m_txtCmp.simil( s, t);  // is 1 inside 2?
				results2 = m_txtCmp.simil( t, s); // is 2 inside 1?

				results = (results+results2);  // the closer we are to 2.0, the better the match

				if (results > topTen)	// are we in the top 10?
				{
					//compare +="\r\n";
					resultsList.name[resultsList.index] = fullFilename+ext;
					resultsList.score[resultsList.index] = results;
					resultsList.index++;

					if (resultsList.index > 9)
						sortResults(resultsList, topTen);

				}

		} // first letter match
		
   
   } // while 

	// change this to an accuracy slider?
	sortResults(resultsList, topTen);
	if (resultsList.score[0] < 1.25) 
			return false;
		
	bestMatch = resultsList.name[0];
	return true;
}
void CFuzzyRenameDlg::sortResults(resultsArray &resultsList, float &topTen)
{
  int i, j;
  float temp;
  CString stemp;

  for (i = (10 - 1); i >= 0; i--)
  {
    for (j = 1; j <= i; j++)
    {
		if (resultsList.score[j-1] < resultsList.score[j])
      {
        temp = resultsList.score[j-1];
        resultsList.score[j-1] = resultsList.score[j];
        resultsList.score[j] = temp;

		stemp = resultsList.name[j-1];
        resultsList.name[j-1] = resultsList.name[j];
        resultsList.name[j] = stemp;

      }
    }
  }

  topTen = resultsList.score[9]; 
  resultsList.index = 9;	// force new entries to replace last one, resort for every new entry.
}



void CFuzzyRenameDlg::OnBnClickedOk()
{
	// copy the source file to the destination folder, using the target filename.
	// this does everything in the list.

	CProgressDlg progDlg;
	progDlg.Init(PROG_MODE_TIMER, 1000, "Copying files...");

	CString tmp;


	for (int i=0; i<m_nIndex; i++)
	{
		tmp = m_SourceFiles.GetItemText(i,1);
		if (tmp.GetLength() != 0)
		{
			tmp.Insert(0,m_SourcePath);
			CopyFile(tmp,m_DestinationPath+m_SourceFiles.GetItemText(i,2), 0);
		}
	}

	progDlg.DestroyWindow();

}

void CFuzzyRenameDlg::OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;
	int nIndex=-1;
	int lastDeleted=0;
	CString source,dest;
	CPoint point;                                            
     ::GetCursorPos(&point); //where is the mouse?


	nIndex = m_SourceFiles.GetNextItem(-1, LVNI_SELECTED);
	if (nIndex == -1)
		return;

	 CMenu menu; //lets display our context menu :) 

     DWORD dwSelectionMade;                                       
     VERIFY(menu.LoadMenu(IDR_MENU1) );  

	 CMenu *pmenuPopup = menu.GetSubMenu(0);
	 
	 if (m_DestinationPath.GetLength() == 0)
		 pmenuPopup->EnableMenuItem(0, MF_GRAYED+MF_BYPOSITION);	// kill the rename option if there's no place to copy the file to
	 
	 ASSERT(pmenuPopup != NULL);                                       

	 
	 dwSelectionMade = pmenuPopup->TrackPopupMenu( (TPM_LEFTALIGN|TPM_LEFTBUTTON|
                                                       TPM_NONOTIFY|TPM_RETURNCMD),
                                                       point.x, point.y, this
                                );                                
  
	 if (dwSelectionMade == ID__DELETE)
	 {
		 deleteSelected();

	}

	if (dwSelectionMade == ID__MODIFY)
	{
		fixFilename();
	}

	 if (dwSelectionMade == ID__RENAME)
	 {
		 nIndex=-1;
		while (1) 
		{
			nIndex = m_SourceFiles.GetNextItem(nIndex, LVNI_SELECTED);
			if (nIndex == -1)
				break;
			else
			{
				source = m_SourcePath+m_SourceFiles.GetItemText(nIndex,1);
				dest = m_DestinationPath+m_SourceFiles.GetItemText(nIndex,2);
				CopyFile(source, dest, 0);
			}
		}
	 }

	
     pmenuPopup->DestroyMenu(); 

}

void CFuzzyRenameDlg::OnLvnKeydown(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	if (pLVKeyDow->wVKey == 0x2e) // delete key
	{	
		deleteSelected();
	}
	*pResult = 0;
}

// delete all highlighted items...
void CFuzzyRenameDlg::deleteSelected()
{
	int nIndex=0;
	int lastDeleted=0;

	while (1) 
	{
		nIndex = m_SourceFiles.GetNextItem(-1, LVNI_SELECTED);
		if (nIndex == -1)
			break;
		else
		{
			m_SourceFiles.DeleteItem (nIndex);
			lastDeleted = nIndex;
		}
	}
	m_SourceFiles.SetSelectionMark(lastDeleted);
}

void CFuzzyRenameDlg::OnNMDblclk(NMHDR *pNMHDR, LRESULT *pResult)
{

	fixFilename();
	*pResult = 0;
}

void CFuzzyRenameDlg::fixFilename()
{
	int nIndex=0;
	int lastDeleted=0;
	CNewFilenameDlg dlg;
	CString txt;
	while (1) 
	{
		nIndex = m_SourceFiles.GetNextItem(nIndex, LVNI_SELECTED);
		if (nIndex == -1)
			break;
		else
		{
			dlg.m_txt = m_SourceFiles.GetItemText(nIndex,2);
			dlg.DoModal();
			// popup an edit box
			txt = dlg.m_txt;
			m_SourceFiles.SetItemText(nIndex,2,txt);
		}
	}
}